import isPlainObject from 'lodash.isplainobject';
import { subspaced } from 'react-redux-subspace';

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

/**
 * Copyright 2018, IOOF Holdings Limited.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree.
 */

var subspacedEnhancer = function subspacedEnhancer() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$mapExtraState = _ref.mapExtraState,
      mapExtraState = _ref$mapExtraState === undefined ? function () {
    return null;
  } : _ref$mapExtraState;

  return function (identifier) {
    var mapState = function mapState(state, rootState) {
      var componentState = state[identifier];
      if (!isPlainObject(componentState)) {
        return componentState;
      }

      var extraState = mapExtraState(state, rootState);
      if (!isPlainObject(extraState)) {
        if (process.env.NODE_ENV !== 'production' && extraState !== null) {
          throw new TypeError('extra state must be a plain object but received ' + extraState);
        }
        return componentState;
      }

      return _extends({}, extraState, componentState);
    };
    var subspaceEnhancer = subspaced(mapState, identifier);
    return function () {
      return function (Component) {
        return subspaceEnhancer(Component);
      };
    };
  };
};

/**
 * Copyright 2018, IOOF Holdings Limited.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree.
 */

export default subspacedEnhancer;
